'*******************************************************
'* Programme en pic-basic pour  TALCO-CS               *
'* F1GJI le 20 Octbre 2023                               *
'* CIBLE PIC 16F628  horloge interne                   *
'* VERSION 10 Canaux  50 MHz pas  25 KHz ou 12,5 KHz   *                      
'*******************************************************
'**Dfinition de la configuration HARD**
'** Dfinition des ports  **

    device 16f628

    cmcon = 7  ' dsactive le comparateur si utilisation des ports A avec  16F628 !
    
    EN     VAR   PORTB.1     'valid 
    DAT    VAR   PORTB.2     'donnes
    CLK    VAR   PORTB.3     'horloge bus 3 fils
    
    
    
    input porta.2             ' CANAL-8-H
    input porta.3             ' CANAL-9-I
    input porta.4             ' CANAL-10-J
    input PORTA.1             ' CANAL-1-A
    input porta.0             ' CANAL-2-B
    input PORTA.7             ' CANAL-3-C
    input PORTA.6             ' CANAL-4-D
    input portB.7             ' CANAL-5-E
    input portB.6             ' CANAL-6-F
    input portB.5             ' CANAL-7-G
    input PORTB.4             ' TX - MIC

    
    OUTPUT PORTB.0           ' ALT
    OUTPUT PORTB.1           ' EN
    OUTPUT PORTB.2           ' DAT
    OUTPUT PORTB.3           ' CLK
    
    PORTB.0 = 0
    porta.1 = 1
    porta.2 = 1
    porta.3 = 1
    porta.4 = 1
    porta.0 = 1
    porta.7 = 1
    porta.6 = 1
    portB.7 = 1
    portB.6 = 1
    portB.5 = 1
    portB.4 = 1
    
'**Dclaration des variables***

   MRXV    VAR  WORD
   ARXV    VAR  BYTE
   MTXV    VAR  WORD
   ATXV    VAR  BYTE
   
   R   VAR word      'diviseur rfrence PLL

'-------------------------------------------------------------------------------------------------------------------------------------------------------------------



DEBUT:

    if PORTA.1 = 0  then gosub PLLA  ' 51,5125 MHZ  RX / TX  pas 12,5      canal 1
    pause 100
    if PORTA.0 = 0  then gosub PLLB  ' 51,4125 MHZ  RX / TX  pas 12,5      canal 2
    pause 100
    if PORTA.7 = 0  then gosub PLLC  ' 51.500  MHz RX  / TX  pas 25        canal 3
    pause 100
    if PORTA.6 = 0  then gosub PLLD  ' 50,525  MHz RX /  TX  pas 12,5      canal 4
    pause 100
    if portB.7 = 0  then gosub PLLE  ' 50.500  MHz RX /  TX  pas 25        canal 5
    pause 100
    if portB.6 = 0  then gosub PLLF  ' 50.5125  MHz RX /  TX  pas 12.5      canal 6
    pause 100
    if portB.5 = 0  then gosub PLLG  ' 50.600  MHz RX /  TX  pas 25        canal 7
    pause 100
    if porta.2 = 0  then gosub PLLH  ' 51.550 MHz RX /   TX  pas 25        canal 8
    pause 100
    if porta.3 = 0  then gosub PLLI  ' 50.5375  MHz RX / TX  pas 12.5      canal 9
    pause 100
    if porta.4 = 0  then gosub PLLj  ' 51.950   MHZ RX / 51.350 TX pas 25  canal 10
    pause 100
    
    goto DEBUT
    
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------   
 
        PLLA:'canal 1
 
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        ' VHF : RX/TX  144.775 MHz   STEP 25 kHz   R = 128
                        '          OL  166.175 MHz
                        ' NRXV = 6647 / MRXV = 103 / ARXV = 55
                        ' NTXV = 5791 / MTXV =  90 / ATXV = 31
                        ' Fi = 10,7 MHz
                        ' R  128 = 25 KHz ou R  256 = 12,5 KHz   
                        
        CLK = 1
        
        MRXV = 124   '  51,5125 MHz
        ARXV = 17
        MTXV = 103   '  51,5125 MHz
        ATXV = 1
    
        R = 256       '   pas de 12.5 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTA
 '-------------------------------------------------------------------------------------------------------------------------------------------------------------------
 
         ALTA:
         
         
         
         
         if PORTA.1 = 1 then goto DEBUT  '  port du CANAL 1
         if PORTB.4 = 0 then gosub TXA    '  PTT Micro
         pause 100
         
         GOTO ALTA
 
 
 
 
 
 
 
 
 
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------
   
          TXA:
 
 
          HIGH EN
          SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTA
 
 
 
 
 
'------------------------------------------------------------------------------------------------------------------------------------------------------------- 
    
            PTTA:
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLA
 
            pause 100
            
            
            goto PTTA
 
 
 
 

'----------------------------------------------------------------------------------------------------------------------------------------------------------------- 

        PLLB:'canal 2
  
  
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        


        CLK = 1
        
        MRXV = 124      '  51,4125 MHz
        ARXV = 9
        MTXV = 102      '  51,4125 MHz  
        ATXV = 33
    
        R = 256         '   pas de 12,5kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTB
  



'---------------------------------------------------------------------------------------------------------------------------------------------------------------------  

         ALTB:
   
           
         if PORTA.0 = 1 then goto DEBUT  '  port du CANAL 1
         if PORTB.4 = 0 then gosub  TXB    '  PTT Micro
         pause 100
         
         GOTO ALTB
   


'-----------------------------------------------------------------------------------------------------------------------------------------------------------------
          TXB:
  
   
          HIGH EN
          SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTB
 







'------------------------------------------------------------------------------------------------------------------------------------------------------------------- 

            PTTB:
      

            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLB
 
            pause 100
            
            
            goto PTTB
            
            
            
'------------------------------------------------------------------------------------------------------------------------------------------------------------            
            
        PLLC:'canal 3
            
            
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        

        CLK = 1
        
        MRXV = 62    '  51,500 MHz
        ARXV = 8
        MTXV = 51     '  51,500 MHz
        ATXV = 20
    
        R = 128         '  pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTC
  
        


'-------------------------------------------------------------------------------------------------------------------------------------------------------------------- 

         ALTC:
   
         if PORTA.7 = 1 then goto DEBUT  '  port du CANAL 1
         if PORTB.4 = 0 then gosub  TXC    '  PTT Micro
         pause 100
         
         GOTO ALTC



'-------------------------------------------------------------------------------------------------------------------------------------------------------------------- 
  
          TXC:
   
          HIGH EN
          SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTC
   
   
   
   
'---------------------------------------------------------------------------------------------------------------------------------------------------------------------- 
            PTTC:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLC
 
            pause 100
            
            
            goto PTTC
    
    



'----------------------------------------------------------------------------------------------------------------------------------------------------------------- 
   
        PLLD:'canal 4
   
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        


        CLK = 1
        
        MRXV = 122       '  50.525 MHz
        ARXV = 18
        MTXV = 101       '  50.525MHz
        ATXV = 2
    
        R = 256          '   pas de 12,5kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTD
  
        
       
   
   





'-----------------------------------------------------------------------------------------------------------------------------------------------------------------

              ALTD:
      
              if PORTA.6 = 1 then goto DEBUT  '  port du CANAL 1
              if PORTB.4 = 0 then gosub TXD    '  PTT Micro
              pause 100
         
              GOTO ALTD




'----------------------------------------------------------------------------------------------------------------------------------------------------------------
    
          TXD:
    
          HIGH EN
          SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTD
    
    

'----------------------------------------------------------------------------------------------------------------------------------------------------------------

            PTTD:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLD
 
            pause 100
            
            
            goto PTTD
    



'----------------------------------------------------------------------------------------------------------------------------------------------------------------


        PLLE:'canal 5
   
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        


        CLK = 1
        
        MRXV = 61       '  50,500 MHz
        ARXV = 8
        MTXV = 50       '  50,500 MHz
        ATXV = 20
    
        R = 128          '  pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTE
  



'----------------------------------------------------------------------------------------------------------------------------------------------------------------

              ALTE:
      
              if PORTB.7 = 1 then goto DEBUT  '  port du CANAL 1
              if PORTB.4 = 0 then gosub TXE    '  PTT Micro
              pause 100
         
              GOTO ALTE





'----------------------------------------------------------------------------------------------------------------------------------------------------------------

          TXE:
    
          HIGH EN
          SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTE





'--------------------------------------------------------------------------------------------------------------------------------------------------------------------

           PTTE:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLE
 
            pause 100
            
            
            goto PTTE
    






'--------------------------------------------------------------------------------------------------------------------------------------------------------------------

        PLLF:'canal 6
   
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        

        CLK = 1
        
        MRXV = 122       '  50,5125 MHz
        ARXV = 17
        MTXV = 101       '  50,5125 MHz
        ATXV = 1
    
        R = 256         '   pas de 12,5 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTF
  




'--------------------------------------------------------------------------------------------------------------------------------------------------------------------

              ALTF:
      
              if PORTB.6 = 1 then goto DEBUT  '  port du CANAL 1
              if PORTB.4 = 0 then gosub TXF    '  PTT Micro
              pause 100
         
              GOTO ALTF




'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
         TXF:
    
          HIGH EN
          SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTF 




'------------------------------------------------------------------------------------------------------------------------------------------------------------------------

            PTTF:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLF
 
            pause 100
            
            
            goto PTTF
    



'-------------------------------------------------------------------------------------------------------------------------------------------------------------------
        PLLG:'canal 7
   
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        

        CLK = 1
        
        MRXV = 61      '  50,600 MHz
        ARXV = 12
        MTXV = 50     '  50,600 MHz
        ATXV = 24
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTG


'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
              ALTG:
      
              if PORTB.5 = 1 then goto DEBUT  '  port du CANAL 1
              if PORTB.4 = 0 then gosub TXG    '  PTT Micro
              pause 100
         
              GOTO ALTG


'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
          TXG:
    
          HIGH EN
          SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTG



'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
            PTTG:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLG
 
            pause 100
            
            
            goto PTTG



'-------------------------------------------------------------------------------------------------------------------------------------------------------------------
        PLLH:'canal 8


             PORTB.0 = 0
        
        
        PAUSE 100                                    
                        ' VHF : RX/TX  144.775 MHz   STEP 25 kHz   R = 128
                        '          OL  166.175 MHz
                        ' NRXV = 6647 / MRXV = 103 / ARXV = 55
                        ' NTXV = 5791 / MTXV =  90 / ATXV = 31
                        ' Fi = 21,4 MHz
                        ' R  128 = 25 KHz ou R  256 = 12,5 KHz   
                        
        CLK = 1
        
        MRXV = 62      '  51,550 MHz
        ARXV = 10
        MTXV = 51      '  51,550 MHz
        ATXV = 22
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTH





'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
        ALTH:
        
         if PORTA.2 = 1 then goto DEBUT  '  port du CANAL 8
         if PORTB.4 = 0 then gosub TXH    '  PTT Micro
         pause 100
         
         GOTO ALTH
 


'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
        TXH:
               HIGH EN
               SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
               LOW EN
               pause 100
          
               goto  PTTH

'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
        PTTH:
                 PORTB.0 = 1
 
                 if PORTB.4 = 1 then goto PLLH
 
                 pause 100
            
            
                 goto PTTH
        


'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
        PLLI:'canal 9
        
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        ' VHF : RX/TX  144.775 MHz   STEP 25 kHz   R = 128
                        '          OL  166.175 MHz
                        ' NRXV = 6647 / MRXV = 103 / ARXV = 55
                        ' NTXV = 5791 / MTXV =  90 / ATXV = 31
                        ' Fi = 21,4 MHz
                        ' R  128 = 25 KHz ou R  256 = 12,5 KHz   
                        
        CLK = 1
        
        MRXV = 122      '  50,5375 MHz
        ARXV = 19
        MTXV = 101       '  50,5375 MHz
        ATXV = 3
    
        R = 256          '  pas de 12,5 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTI





'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
               ALTI:
               
               
               if PORTA.3 = 1 then goto DEBUT  '  port du CANAL 9
               if PORTB.4 = 0 then gosub TXI    '  PTT Micro
               pause 100
         
               GOTO ALTI
      



'---------------------------------------------------------------------------------------------------------------------------------------------------------------------
               TXI:
      
              
               HIGH EN
               SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
               LOW EN
               PAUSE 100
          
               goto  PTTI
      


'---------------------------------------------------------------------------------------------------------------------------------------------------------------------
                 PTTI:
      
                 PORTB.0 = 1
 
                 if PORTB.4 = 1 then goto PLLI
 
                 pause 100
            
            
                 goto PTTI



'---------------------------------------------------------------------------------------------------------------------------------------------------------------------
      PLLJ:'canal 10
      
      
      PORTB.0 = 0
        
        
        PAUSE 100                                    
                        ' VHF : RX/TX  144.775 MHz   STEP 25 kHz   R = 128
                        '          OL  166.175 MHz
                        ' NRXV = 6647 / MRXV = 103 / ARXV = 55
                        ' NTXV = 5791 / MTXV =  90 / ATXV = 31
                        ' Fi = 21,4 MHz
                        ' R  128 = 25 KHz ou R  256 = 12,5 KHz   
                        
        CLK = 1
        
        MRXV = 62     '  51,950 MHz
        ARXV = 26
        MTXV = 51     '  51.350 MHz
        ATXV = 14
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXV\7,MRXV\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTJ
      



'---------------------------------------------------------------------------------------------------------------------------------------------------------------------
               ALTJ:
                 
               if PORTA.4 = 1 then goto DEBUT  '  port du CANAL 10
               if PORTB.4 = 0 then gosub TXJ    '  PTT Micro
               pause 100
         
               GOTO ALTJ
      
        


'---------------------------------------------------------------------------------------------------------------------------------------------------------------------
               TXJ:
        
               HIGH EN
               SHIFTOUT DAT,CLK,5,[ATXV\7,MTXV\10,R\11]
               LOW EN
               PAUSE 100
          
               goto  PTTJ
      


'---------------------------------------------------------------------------------------------------------------------------------------------------------------------
                 PTTJ:
         
                 PORTB.0 = 1
 
                 if PORTB.4 = 1 then goto PLLJ
 
                 pause 100
            
            
                 goto PTTJ

         

'---------------------------------------------------------------------------------------------------------------------------------------------------------------------





   END
