'*******************************************************
'* Programme en pic-basic pour  TALCO-CS               *
'* F1GJI le 30 Juillet 2022                            *
'*CIBLE PIC 16F628  horloge interne                    *
'*VERSION 10 Canaux  UHF pas  25 KHz                               '   
'*******************************************************
'**Dfinition de la configuration HARD**
'** Dfinition des ports  **

    cmcon = 7  'dsactive le comparateur si utilisation des ports A avec  16F628 !
    
    EN     VAR   PORTB.1     'valid 
    DAT    VAR   PORTB.2     'donnes
    CLK    VAR   PORTB.3     'horloge bus 3 fils
    
    
    input porta.2            ' CANAL-8-H
    input porta.3             ' CANAL-9-I
    input porta.4             ' CANAL-10-J
    input PORTA.1             ' CANAL-1-A
    input porta.0             ' CANAL-2-B
    input PORTA.7             ' CANAL-3-C
    input PORTA.6             ' CANAL-4-D
    input portB.7             ' CANAL-5-E
    input portB.6             ' CANAL-6-F
    input portB.5             ' CANAL-7-G
    input PORTB.4             ' TX - MIC

    
    OUTPUT PORTB.0           ' ALT
    OUTPUT PORTB.1           ' EN
    OUTPUT PORTB.2           ' DAT
    OUTPUT PORTB.3           ' CLK
    
    PORTB.0 = 0
    porta.1 = 1
    porta.2 = 1
    porta.3 = 1
    porta.4 = 1
    porta.0 = 1
    porta.7 = 1
    porta.6 = 1
    portB.7 = 1
    portB.6 = 1
    portB.5 = 1
    portB.4 = 1
    
'**Dclaration des variables***

   MRXU    VAR  WORD
   ARXU    VAR  BYTE
   MTXU    VAR  WORD
   ATXU    VAR  BYTE 
   
   R   VAR word      'diviseur rfrence PLL

'-------------------------------------------------------------------------------------------------------------------------------------------------------------------



DEBUT:

    if PORTA.1 = 0  then gosub PLLA  ' 430,025  MHZ  RX / TX (X Rousse F1ZES)
    pause 100
    if PORTA.0 = 0  then gosub PLLB  ' 439,975  MHZ  RX / 430,375  TX   (Ro Mt cindre)
    pause 100
    if PORTA.7 = 0  then gosub PLLC  ' 430,150  MHz RX  / 439,550  TX  (Jora F1ZEX)
    pause 100
    if PORTA.6 = 0  then gosub PLLD  ' 431,875 MHz RX /  430,275   TX   (RU11)
    pause 100
    if portB.7 = 0  then gosub PLLE  ' 439,525 MHz RX / TX   (PILAT F1ZTA)
    pause 100
    if portB.6 = 0  then gosub PLLF  ' 432,525 MHz RX /  TX   (Simplex)
    pause 100
    if portB.5 = 0  then gosub PLLG  ' 432,500 MHz RX /  TX  (Simplex)
    pause 100
    if porta.2 = 0  then gosub PLLH  ' 430,125 MHz RX /  TX  (ADRASEC X Rousse)
    pause 100
    if porta.3 = 0  then gosub PLLI  ' 439,925 MHz RX / TX   (ADRASEC Relais Transpondeur 145,425)
    pause 100
    if porta.4 = 0  then gosub PLLJ  ' 431,300 MHz RX / TX    ( F1ZTA- PILAT )
    pause 100
    
    goto DEBUT
    
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------   
 
 PLLA:
 
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                                      '' UHF : RX/TX  430.025 MHz  STEP 25 kHz    R = 128
                                      '          OL  385.025 MHz
                                      ' NRXU = 15401 / MRXU =240 / ARXU = 41
                                      ' NTXU = 17201 / MTXU =268 / ATXU = 49
                                      ' FI = 45 MHz
                                      ' R  128 = 25 KHz ou R  256 = 12,5 KHz   

        CLK = 1
        
        MRXU = 240   '430,025  MHz
        ARXU = 41
        MTXU = 268   '430,025  MHz
        ATXU = 49
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
        
       
        GOTO  ALTA
 '-------------------------------------------------------------------------------------------------------------------------------------------------------------------
 
 ALTA:
         
         
         
         
         if PORTA.1 = 1 then goto DEBUT  '  port du CANAL 1
         if PORTB.4 = 0 then gosub TXA    '  PTT Micro
         pause 100
         
         GOTO ALTA
 
 
 
 
 
 
 
 
 
'------------------------------------------------------------------------------------------------------------------------------------------------------------------------
   
 TXA:
 
 
          HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTA
 
 
 
 
 
'------------------------------------------------------------------------------------------------------------------------------------------------------------- 
    
 PTTA:
             PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLA
 
            pause 100
            
            
            goto PTTA
 
 
 
 

'----------------------------------------------------------------------------------------------------------------------------------------------------------------- 

  PLLB:
  
  
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        


        CLK = 1
        
        MRXU = 246   '439,975  MHz
        ARXU = 55
        MTXU = 268   '430,375  MHz
        ATXU = 63
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTB
  



'---------------------------------------------------------------------------------------------------------------------------------------------------------------------  

   ALTB:
   
           
         if PORTA.0 = 1 then goto DEBUT  '  port du CANAL 2
         if PORTB.4 = 0 then gosub TXB    '  PTT Micro
         pause 100
         
         GOTO ALTB
   


'-----------------------------------------------------------------------------------------------------------------------------------------------------------------
  TXB:
  
   
          HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTB
 







'------------------------------------------------------------------------------------------------------------------------------------------------------------------- 

      PTTB:
      

            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLB
 
            pause 100
            
            
            goto PTTB
            
            
            
'------------------------------------------------------------------------------------------------------------------------------------------------------------            
            
  PLLC:
            
            
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        

        CLK = 1
        
        MRXU = 240   '430,150  MHz
        ARXU = 46
        MTXU = 274   '439,550  MHz
        ATXU = 46
    
        R = 128         '  pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTC
  
        


'-------------------------------------------------------------------------------------------------------------------------------------------------------------------- 

   ALTC:
   
         if PORTA.7 = 1 then goto DEBUT  '  port du CANAL 3
         if PORTB.4 = 0 then gosub TXC    '  PTT Micro
         pause 100
         
         GOTO ALTC



'-------------------------------------------------------------------------------------------------------------------------------------------------------------------- 
  
   TXC:
   
          HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTC
   
   
   
   
'---------------------------------------------------------------------------------------------------------------------------------------------------------------------- 
    PTTC:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLC
 
            pause 100
            
            
            goto PTTC
    
    



'----------------------------------------------------------------------------------------------------------------------------------------------------------------- 
   
   PLLD:
   
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        


        CLK = 1
        
        MRXU = 241   '431,875  MHz
        ARXU = 51
        MTXU = 268   '430,275 MHz
        ATXU = 59
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTD
  
        
       
   
   





'-----------------------------------------------------------------------------------------------------------------------------------------------------------------

      ALTD:
      
              if PORTA.6 = 1 then goto DEBUT  '  port du CANAL 4
              if PORTB.4 = 0 then gosub TXD    '  PTT Micro
              pause 100
         
              GOTO ALTD




'----------------------------------------------------------------------------------------------------------------------------------------------------------------
    
    TXD:
    
         HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTD
    
    

'----------------------------------------------------------------------------------------------------------------------------------------------------------------

    PTTD:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLD
 
            pause 100
            
            
            goto PTTD
    



'----------------------------------------------------------------------------------------------------------------------------------------------------------------


        PLLE:
   
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        


        CLK = 1
        
        MRXU = 246   '439,525  MHz
        ARXU = 37
        MTXU = 274   '439,525 MHz
        ATXU = 45
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTE
  



'----------------------------------------------------------------------------------------------------------------------------------------------------------------

         ALTE:
      
              if PORTB.7 = 1 then goto DEBUT  '  port du CANAL 5
              if PORTB.4 = 0 then gosub  TXE    '  PTT Micro
              pause 100
         
              GOTO ALTE





'----------------------------------------------------------------------------------------------------------------------------------------------------------------

          TXE:
    
          HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTE





'--------------------------------------------------------------------------------------------------------------------------------------------------------------------

           PTTE:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLE
 
            pause 100
            
            
            goto PTTE
    






'--------------------------------------------------------------------------------------------------------------------------------------------------------------------

        PLLF:
   
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        

        CLK = 1
        
        MRXU = 242   '432,525 MHz
        ARXU = 13
        MTXU = 270   '432,525  MHz
        ATXU = 21
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTF
  




'--------------------------------------------------------------------------------------------------------------------------------------------------------------------

         ALTF:
      
              if PORTB.6 = 1 then goto DEBUT  '  port du CANAL 6
              if PORTB.4 = 0 then gosub TXF    '  PTT Micro
              pause 100
         
              GOTO ALTF




'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
         TXF:
    
          HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTF 




'------------------------------------------------------------------------------------------------------------------------------------------------------------------------

          PTTF:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLF
 
            pause 100
            
            
            goto PTTF
    



'-------------------------------------------------------------------------------------------------------------------------------------------------------------------
        PLLG:
   
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        

        CLK = 1
        
        MRXU = 242   '432,500  MHz
        ARXU = 12
        MTXU = 270  '432,500  MHz
        ATXU = 20
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTG


'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
        ALTG:
      
              if PORTB.5 = 1 then goto DEBUT  '  port du CANAL 7
              if PORTB.4 = 0 then gosub TXG    '  PTT Micro
              pause 100
         
              GOTO ALTG


'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
       TXG:
    
          HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTG



'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
         PTTG:
    
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLG
 
            pause 100
            
            
            goto PTTG



'-------------------------------------------------------------------------------------------------------------------------------------------------------------------
         PLLH:
         
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        

        CLK = 1
        
        MRXU = 240   '430,125  MHz
        ARXU = 45
        MTXU = 268    '430,125  MHz
        ATXU = 53
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTH





'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
       ALTH:
            
            if PORTa.2 = 1 then goto DEBUT  '  port du CANAL 8
            if PORTB.4 = 0 then gosub TXH   '  PTT Micro
            pause 100
         
            GOTO ALTH


'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
        TXH:
            
          HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTH

        

'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
         PTTH:
         
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLH
 
            pause 100
            
            
            goto PTTH



'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
           PLLI:
           
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        

        CLK = 1
        
        MRXU = 246   '439,925  MHz
        ARXU = 53
        MTXU = 274   '439,925   MHz
        ATXU = 61
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTI





'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
         ALTI:
         
            if PORTa.3 = 1 then goto DEBUT  '  port du CANAL 9
            if PORTB.4 = 0 then gosub TXI   '  PTT Micro
            pause 100
         
            GOTO ALTI



'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
        TXI:
        
          HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTI
        

'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
         PTTI:
         
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLI
 
            pause 100
            
            
            goto PTTI

         
'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
         PLLJ:
         
        PORTB.0 = 0
        
        
        PAUSE 100                                    
                        

        CLK = 1
        
        MRXU = 241   '431,300  MHz
        ARXU = 28
        MTXU = 269   '431,300  MHz
        ATXU = 36
    
        R = 128          'pas de 25 kHz

        pause 500
        
        HIGH EN   
        SHIFTOUT DAT,CLK,5,[ARXU\7,MRXU\10,R\11]
        LOW EN
        PAUSE 100
       
        GOTO  ALTJ
         





'--------------------------------------------------------------------------------------------------------------------------------------------------------------------

       ALTJ:
       
            if PORTa.4 = 1 then goto DEBUT  '  port du CANAL 10
            if PORTB.4 = 0 then gosub TXJ   '  PTT Micro
            pause 100
         
            GOTO ALTJ

       
       
'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
       TXJ:
            
          HIGH EN   
          SHIFTOUT DAT,CLK,5,[ATXU\7,MTXU\10,R\11]
          LOW EN
          PAUSE 100
          
          goto  PTTJ
       



'--------------------------------------------------------------------------------------------------------------------------------------------------------------------
       PTTJ:
       
            PORTB.0 = 1
 
            if PORTB.4 = 1 then goto PLLJ
 
            pause 100
            
            
            goto PTTJ




'--------------------------------------------------------------------------------------------------------------------------------------------------------------------



   END
